| Version: 3.0.5

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Modules Pages
Public Member Functions | Public Attributes | List of all members
wxPoint Class Reference
Class List by Category » Data Structures

`#include <wx/gdicmn.h>`

## Detailed Description

A wxPoint is a useful data structure for graphics operations.

It contains integer x and y members. See wxRealPoint for a floating point version.

Note that the width and height stored inside a wxPoint object may be negative and that wxPoint functions do not perform any check against negative values (this is used to e.g. store the special -1 value in wxDefaultPosition instance).

##

Library: wxCore
Category: Data Structures

Predefined objects/pointers: wxDefaultPosition

See also
  wxRealPoint

## Public Member Functions

| wxPoint ()
| Constructs a point. More...
| wxPoint (int x, int y)
| Initializes the point object with the given x and y coordinates. More...
| wxPoint (const wxRealPoint &pt)
| Converts the given wxRealPoint (with floating point coordinates) to a wxPoint instance. More...
Miscellaneous operators
Note that these operators are documented as class members (to make them easier to find) but, as their prototype shows, they are implemented as global operators; note that this is transparent to the user but it helps to understand why the following functions are documented to take the wxPoint they operate on as an explicit argument.
wxPoint & | operator= (const wxPoint &pt)
bool | operator== (const wxPoint &p1, const wxPoint &p2)
bool | operator!= (const wxPoint &p1, const wxPoint &p2)
wxPoint | operator+ (const wxPoint &p1, const wxPoint &p2)
wxPoint | operator- (const wxPoint &p1, const wxPoint &p2)
wxPoint & | operator+= (const wxPoint &pt)
wxPoint & | operator-= (const wxPoint &pt)
wxPoint | operator+ (const wxPoint &pt, const wxSize &sz)
wxPoint | operator- (const wxPoint &pt, const wxSize &sz)
wxPoint | operator+ (const wxSize &sz, const wxPoint &pt)
wxPoint | operator- (const wxSize &sz, const wxPoint &pt)
wxPoint & | operator+= (const wxSize &sz)
wxPoint & | operator-= (const wxSize &sz)
wxSize | operator/ (const wxPoint &sz, int factor)
wxSize | operator* (const wxPoint &sz, int factor)
wxSize | operator* (int factor, const wxSize &sz)
wxSize & | operator/= (int factor)
wxSize & | operator*= (int factor)
Defaults handling.
Test for and set non-specified wxPoint components. Although a wxPoint is always initialized to (0, 0), wxWidgets commonly uses wxDefaultCoord (defined as `-1`) to indicate that a point hasn't been initialized or specified. In particular, wxDefaultPosition is used in many places with this meaning.
bool | IsFullySpecified () const
| Returns true if neither of the point components is equal to wxDefaultCoord. More...
void | SetDefaults (const wxPoint &pt)
| Combine this object with another one replacing the uninitialized values. More...

## Public Attributes

int | x
| x member. More...
int | y
| y member. More...

## Constructor & Destructor Documentation

wxPoint::wxPoint | ( |  | ) |

Constructs a point.

Initializes the internal x and y coordinates to zero.

wxPoint::wxPoint | ( | int | x,
|  | int | y
| ) |  |

Initializes the point object with the given x and y coordinates.

wxPoint::wxPoint | ( | const wxRealPoint & | pt | ) |

Converts the given wxRealPoint (with floating point coordinates) to a wxPoint instance.

Notice that this truncates the floating point values of pt components, if you want to round them instead you need to do it manually, e.g.

#include <wx/math.h> // for wxRound()
wxRealPoint rp = ...;
wxPoint p(wxRound(rp.x), wxRound(rp.y));

## Member Function Documentation

bool wxPoint::IsFullySpecified | ( |  | ) | const

Returns true if neither of the point components is equal to wxDefaultCoord.

This method is typically used before calling SetDefaults().

Since
  2.9.2

bool wxPoint::operator!= | ( | const wxPoint & | p1,
|  | const wxPoint & | p2
| ) |  |

wxSize wxPoint::operator* | ( | const wxPoint & | sz,
|  | int | factor
| ) |  |

wxSize wxPoint::operator* | ( | int | factor,
|  | const wxSize & | sz
| ) |  |

wxSize& wxPoint::operator*= | ( | int | factor | ) |

wxPoint wxPoint::operator+ | ( | const wxPoint & | p1,
|  | const wxPoint & | p2
| ) |  |

wxPoint wxPoint::operator+ | ( | const wxPoint & | pt,
|  | const wxSize & | sz
| ) |  |

wxPoint wxPoint::operator+ | ( | const wxSize & | sz,
|  | const wxPoint & | pt
| ) |  |

wxPoint& wxPoint::operator+= | ( | const wxPoint & | pt | ) |

wxPoint& wxPoint::operator+= | ( | const wxSize & | sz | ) |

wxPoint wxPoint::operator- | ( | const wxPoint & | p1,
|  | const wxPoint & | p2
| ) |  |

wxPoint wxPoint::operator- | ( | const wxPoint & | pt,
|  | const wxSize & | sz
| ) |  |

wxPoint wxPoint::operator- | ( | const wxSize & | sz,
|  | const wxPoint & | pt
| ) |  |

wxPoint& wxPoint::operator-= | ( | const wxPoint & | pt | ) |

wxPoint& wxPoint::operator-= | ( | const wxSize & | sz | ) |

wxSize wxPoint::operator/ | ( | const wxPoint & | sz,
|  | int | factor
| ) |  |

wxSize& wxPoint::operator/= | ( | int | factor | ) |

wxPoint& wxPoint::operator= | ( | const wxPoint & | pt | ) |

bool wxPoint::operator== | ( | const wxPoint & | p1,
|  | const wxPoint & | p2
| ) |  |

void wxPoint::SetDefaults | ( | const wxPoint & | pt | ) |

Combine this object with another one replacing the uninitialized values.

It is typically used like this:

if ( !pos.IsFullySpecified() )
{
pos.SetDefaults(GetDefaultPosition());
}

See also
  IsFullySpecified()

Since
  2.9.2

## Member Data Documentation

int wxPoint::x

x member.

int wxPoint::y

y member.